"use strict";
var Promise = require("bluebird");
var fs_1 = require("fs");
var path_1 = require("path");
var async_1 = require("async");
var fs = require("fs");
function allDirectories(directory) {
    return new Promise(function (resolve, reject) {
        fs_1.readdir(directory, function (err, files) {
            if (err) {
                reject(err);
                return;
            }
            var dirs = [];
            async_1.each(files, function (dirName, cb) {
                var dirPath = path_1.join(directory, dirName);
                fs_1.stat(dirPath, function (err, stats) {
                    if (err) {
                        cb(err);
                        return;
                    }
                    if (stats.isDirectory()) {
                        dirs.push(dirPath);
                    }
                    cb();
                });
            }, function (err) {
                if (err)
                    reject(err);
                else
                    resolve(dirs);
            });
        });
    });
}
exports.allDirectories = allDirectories;
function permutations(array1, array2) {
    var permutations = [];
    for (var i = 0; i < array1.length; i++) {
        for (var j = 0; j < array2.length; j++) {
            permutations.push([array1[i], array2[j]]);
        }
    }
    return permutations;
}
exports.permutations = permutations;
function PromiseCache(func) {
    var cache;
    var currentlyExecutingPromise;
    return function () {
        if (cache != null)
            return Promise.resolve(cache);
        if (currentlyExecutingPromise != null)
            return currentlyExecutingPromise;
        var promise = func().then(function (res) {
            if (cache == null) {
                cache = res;
            }
            currentlyExecutingPromise = null;
            return res;
        });
        currentlyExecutingPromise = promise;
        return promise;
    };
}
exports.PromiseCache = PromiseCache;
function flatten(arr) {
    return Array.prototype.concat.apply([], arr);
}
exports.flatten = flatten;
function canExecute(path) {
    return new Promise(function (resolve) {
        fs.access(path, fs.X_OK, function (err) {
            if (err)
                resolve(false);
            else
                resolve(true);
        });
    });
}
exports.canExecute = canExecute;
